#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/* cli->srv */
#define	OP_STUDENT_ID		0
/* buffer contains a null terminated string, which is the student name/ID */
#define	OP_SET_PROBLEM_NUM	1
/* buffer contains problem number as unsigned long */
#define	OP_MORE_DATA		2
/* buffer contains a packet fragment (part of problem solution) */
#define	OP_EVALUATE		3
/* problem data completed, evaluate score */
#define	OP_DONE			4
/* disconnect -- any missing problem were not completed */
#define	MAX_OP			OP_DONE

/* srv->cli */
#define	RESP_SCORE		5
/* buffer contains an unsigned short,
   which is the score for the just completed problem */
#define	RESP_FINAL_SCORE	6
/* buffer contains an unsigned long,
   which is the total score for the problem set */

/* all longs are stored in network byte order */

/* Server globals: */

extern int	debug;

/* STUDENT SUPPLIED CODE: */

/* returns OP_* code above, with len/bufp set appropriately */
extern int	client_op(unsigned short	*buflenp,
			  char			**bufpp);
/*
 * server calls this with OP_* code (above),
 * with data in buffer of len buflen
 */
extern void	client_answer(int		op,
			      unsigned short	buflen,
			      const char	*buffer);

